import sys

versionString = '%s: version 1.1' % sys.argv[0]
print versionString

try:
    import psyco
    psyco.full()
except:
    print 'psyco not running'

from som import SOM
from mapGraphics import saveMapPNG

if len(sys.argv) < 4:
    print "usage: python %s somfile inmap1,inmap2[,inmap3,...] outprefix [-vmin fraction] [-vmax fraction]" % sys.argv[0]
    print "\n\twhere somfile and all inmaps are of the same row x col size and fraction is a float between 0. and 1.\n"
    sys.exit(0)

somfile = sys.argv[1]
inmaplist = sys.argv[2].split(',')
outprefix = sys.argv[3]

maxValue = 0
if '-vmax' in sys.argv:
    maxValue = float(sys.argv[sys.argv.index('-vmax') + 1])

minValue = 0
if '-vmax' in sys.argv:
    minValue = float(sys.argv[sys.argv.index('-vmin') + 1])

mapMinValue = minValue
mapMaxValue = maxValue

mysom = SOM(initialFile=somfile)
outmap = mysom.newMap(numDim=0)

numMaps = float(len(inmaplist))
for inmapfile in inmaplist:
    inmap = mysom.readMap(inmapfile)
    for (row, col) in mysom.units:
        outmap[row][col] += inmap[row][col]/numMaps

mysom.saveMap(outmap, outprefix + '.map')
saveMapPNG(outmap, outprefix, minVal=mapMinValue, maxVal=mapMaxValue, grid=mysom.gridType)
