import sys, os, string

versionString = '%s: version 1.2' % sys.argv[0]
print versionString

if len(sys.argv) < 4:
	print "usage: python %s runID genome prefix [-submit]" % sys.argv[0]
	print "\n\twhere prefix must be the absolute path and file prefix for .units files."
        print "will not submit to condor_queue by default, in case CISTEMATIC_ROOT needs to be changed\n"
	sys.exit(1)

runID = sys.argv[1]
genome = sys.argv[2]
inprefix = sys.argv[3]
memRequest = 1000

doSubmit = False
if '-submit' in sys.argv:
    doSubmit = True

fields = inprefix.split('/')
filedir = string.join(fields[:-1],'/')
fileprefix = fields[-1].strip()

allfiles = os.listdir(filedir)

outfile = open(runID + '.condorsub' ,'w')
outfile.write("""universe=vanilla

environment="ERANGEPATH=/woldlab/loxcyc/data00/alim/commoncode CISTEMATIC_ROOT=/woldlab/loxcyc/data00/alim/genome3 PYTHONPATH=/woldlab/loxcyc/data00/alim/genome3:/woldlab/loxcyc/data00/alim/commoncode SOMPATH=/woldlab/loxcyc/data00/alim/testcode/SOM "

executable = /usr/bin/python

log=%s.log
output=%s.out
error=%s.err
request_cpus = 1
request_memory = %d
request_disk = 0
""" % (runID, runID, runID, memRequest)
)

submitCount = 0
for filename in allfiles:
	if fileprefix in filename and '.unit' in filename:
            infilename = filedir + '/' + filename
            genefilename = filedir + '/' + filename.replace('.unit','.genes')
            outfile.write("\narguments = /woldlab/loxcyc/data00/alim/commoncode/getallgenes.py %s %s %s -cache\n\nqueue\n" % (genome, infilename, genefilename))
            submitCount += 1
outfile.close()

print "readied %d jobs" % submitCount

if doSubmit:
    os.system("condor_submit %s.condorsub" % runID)

