import sys, os, string

versionString = '%s: version 1.2' % sys.argv[0]
print versionString

if len(sys.argv) < 6:
	print "usage: python %s runID rows cols genome prefix " % sys.argv[0]
	print "\n\twhere prefix must be the absolute path and file prefix for .genes files.\n"
	sys.exit(1)

runID = sys.argv[1]
rows = int(sys.argv[2])
cols = int(sys.argv[3])
genome = sys.argv[4]
inprefix = sys.argv[5]
memRequest = 1000

fields = inprefix.split('/')
filedir = string.join(fields[:-1],'/')
fileprefix = fields[-1].strip()

somsize = rows * cols
allfiles = os.listdir(filedir)

outfile = open(runID + '.condorsub' ,'w')
outfile.write("""universe=vanilla

environment="ERANGEPATH=/woldlab/loxcyc/data00/alim/commoncode CISTEMATIC_ROOT=/woldlab/loxcyc/data00/alim/genome3 PYTHONPATH=/woldlab/loxcyc/data00/alim/genome3:/woldlab/loxcyc/data00/alim/commoncode SOMPATH=/woldlab/loxcyc/data00/alim/testcode/SOM "

executable = /usr/bin/python

log=%s.log
output=%s.out
error=%s.err
request_cpus = 1
request_memory = %d
request_disk = 0
""" % (runID, runID, runID, memRequest)
)

submitCount = 0
for filename in allfiles:
	if fileprefix in filename and '.genes' in filename:
            infilename = filedir + '/' + filename
            gofilename = filedir + '/gostat/' + filename.replace('.genes','')
            outfile.write("\narguments = /woldlab/loxcyc/data00/alim/commoncode/analyzego.py %s %s %s -trials %d\n\nqueue\n" % (genome, infilename, gofilename, somsize))
            submitCount += 1
outfile.close()

print "submitted %d jobs" % submitCount

os.system("condor_submit %s.condorsub" % runID)

