import sys, os

versionString = '%s: version 1.2' % sys.argv[0]
print versionString

if len(sys.argv) < 7:
	print "usage: python %s runID numTrials rows cols matrix outprefix [-time count] [-rate float] [-memory value] " % sys.argv[0]
	print "\n\twhere all paths must be absolute.\n"
	sys.exit(1)

runID = sys.argv[1]
trials = int(sys.argv[2])
rows = int(sys.argv[3])
cols = int(sys.argv[4])
matrixfile = sys.argv[5]
outprefix = sys.argv[6]

timesteps = 10000000
if '-time' in sys.argv:
    timesteps = int(sys.argv[sys.argv.index('-time') + 1])

memRequest = 10000
if '-memory' in sys.argv:
    memRequest = int(sys.argv[sys.argv.index('-memory') + 1])

rate = 0.2
if '-rate' in sys.argv:
    rate = float(sys.argv[sys.argv.index('-rate') + 1])

outfile = open(runID + '.condorsub' ,'w')
outfile.write("""universe=vanilla

environment="ERANGEPATH=/woldlab/loxcyc/data00/alim/commoncode CISTEMATIC_ROOT=/woldlab/loxcyc/data00/alim/genome3 PYTHONPATH=/woldlab/loxcyc/data00/alim/genome3:/woldlab/loxcyc/data00/alim/commoncode SOMPATH=/woldlab/loxcyc/data00/alim/testcode/SOM "

executable = /usr/bin/python

log=%s.$(Process).log
output=%s.$(Process).out
error=%s.$(Process).err
request_cpus = 1
request_memory = %d
request_disk = 0
""" % (runID, runID, runID, memRequest)
)

for index in range(trials):
	outFilename = outprefix + '.' + str(index) + '.som'
        scoreFilename = outprefix + '.' + str(index) + '.scores'
	outfile.write("\narguments = -u /woldlab/loxcyc/data00/alim/testcode/SOM/trainsom.py %d %d %s %s -trials 1 -scorefile %s -learn %f -timesteps %d -topology toroid\n\nqueue\n" % (rows, cols, matrixfile, outFilename, scoreFilename, rate, timesteps))
outfile.close()

os.system("condor_submit %s.condorsub" % runID)

