import sys

versionString = '%s: version 1.1' % sys.argv[0]
print versionString

try:
    import psyco
    psyco.full()
except:
    print 'psyco not running'

from som import SOM
from mapGraphics import saveMapPNG, coordTranslate
from math import sqrt

if len(sys.argv) < 4:
    print "usage: python %s somfile inmap1 inmap2" % sys.argv[0]
    sys.exit(0)

somfile = sys.argv[1]
inmapfile1 = sys.argv[2]
inmapfile2 = sys.argv[3]

maxValue = 0
if '-vmax' in sys.argv:
    maxValue = float(sys.argv[sys.argv.index('-vmax') + 1])

minValue = 0
if '-vmax' in sys.argv:
    minValue = float(sys.argv[sys.argv.index('-vmin') + 1])

def localPearsonCorrelation(colA, colB):
    meanA = 0.0
    meanB = 0.0
    
    length = len(colA)
    if length > len(colB):
        length = len(colB)
    
    for index in range(length):
        meanA += colA[index]
        meanB += colB[index]
    
    meanA /= length
    meanB /= length
    
    numerator = 0.0
    denominatorA = 0.0
    denominatorB = 0.0
    
    for index in range(length):
        numerator += (colA[index] - meanA) * (colB[index] - meanB)
        denominatorA += (colA[index] - meanA) * (colA[index] - meanA)
        denominatorB += (colB[index] - meanB) * (colB[index] - meanB)
    
    if denominatorA == 0.0 or denominatorB == 0.0:
        return 0.0
        
    return (numerator / sqrt(denominatorA * denominatorB))

mysom = SOM(initialFile=somfile)

#xmax = mysom.outCols
#ymax = mysom.outRows
#
inmap1 = mysom.readMap(inmapfile1)
inmap2 = mysom.readMap(inmapfile2)
#
#mapMinValue = minValue
#mapMaxValue = maxValue
#unitValueList = []
#
#avalueList = []
#bvalueList = []
#for (row, col) in mysom.units:
#    avalueList.append(inmap1[row][col])
#    bvalueList.append(inmap2[row][col])
#
#print sum(avalueList)
#print sum(bvalueList)

corr = mysom.mapPearsonCorrelation(inmap1,inmap2)
print "Pearson Correlation of %.3f" % corr

