import sys

versionString = '%s: version 1.4' % sys.argv[0]
print versionString

try:
    import psyco
    psyco.full()
except:
    print 'psyco not running'

from som import SOM
from mapGraphics import saveMapPNG, coordTranslate

if len(sys.argv) < 4:
    print "usage: python %s somfile listfile outprefix [-cluster]" % sys.argv[0]
    print "\n\twhere the list file consists of three rows of row\tcol\tvalue"
    print "\tor, given the -cluster flag, in unit_row_col format with value of 1"
    sys.exit(0)

somfile = sys.argv[1]
listfile = open(sys.argv[2])
outprefix = sys.argv[3]

asCluster = False
if '-cluster' in sys.argv:
    asCluster = True

mysom = SOM(initialFile=somfile)
outmap = mysom.newMap(numDim=0)

units = []
val = 1
for line in listfile:
    if line[0] == '#':
        continue
    if asCluster:
        fields = line.strip().split('_')
        (header, row, col) = fields
        if '\t' in col:
            (col, val) = col.split('\t')
    else:
        fields = line.strip().split()
        (row, col, val) = fields
    outmap[int(row)][int(col)] = int(val)

mysom.saveMap(outmap, outprefix + '.map')
saveMapPNG(outmap, outprefix, grid=mysom.gridType)