import sys, os

infilename = sys.argv[1]
outprefix = sys.argv[2]

shorten = False
if '-shorten' in sys.argv:
	shorten = True

edgeDict = {}

infile = open(infilename)

print 'reading connectivity'
for line in infile:
	(node1, node2, count) = line.strip().split('\t')
	if shorten:
		(front, node1) = node1.split('_')
		(front, node2) = node2.split('_')
	try:
		if (node2, int(count)) not in edgeDict[node1]:
			edgeDict[node1].append((node2, int(count)))
	except:
		edgeDict[node1] = [(node2, int(count))]
	try:
		if (node1, int(count)) not in edgeDict[node2]:
			edgeDict[node2].append((node1, int(count)))
	except:
		edgeDict[node2] = [(node1, int(count))]

nodeList = edgeDict.keys()
seenNodeDict = {}
seenEdgeDict = {}
currentNodeList = []
currentEdgeList = []
treeList = []
localCount = []

outstat = open(outprefix + '.stats','w')
outstat.write('#gID\tnodes\tedges\tweight\n')

def visitNodes(currentNode):
	#print "visiting %s" % currentNode
	if currentNode in seenNodeDict:
		return
	seenNodeDict[currentNode] = []
	for (node, nodeCount) in edgeDict[currentNode]:
		nodePair = [node, currentNode]
		nodePair.sort()
		if str(nodePair) not in seenEdgeDict:
			if node not in currentNodeList:
				currentNodeList.append(node)
			if nodeCount > 2:
				currentEdgeList.append('\t"%s" -- "%s" [ label = "%d", penwidth=%d, color="red", constraint=false] ; \n' % (currentNode, node, nodeCount, nodeCount))
			else:
				currentEdgeList.append('\t"%s" -- "%s" [ label = "%d", color="red", constraint=false] ; \n' % (currentNode, node, nodeCount))
			seenEdgeDict[str(nodePair)] = 0
			localCount[0] += nodeCount
			try:
				visitNodes(node)
			except:
				pass

print 'getting trees'
for node in nodeList:
	if node not in seenNodeDict:
		#print "starting at %s" % node
		currentNodeList = [node]
		currentEdgeList = []
		localCount = [0]
		outfile = open(outprefix + '.' + node + '.gv', 'w')
		treeList.append(node)
		outfile.write('graph g%s {\n' % node)
		visitNodes(node)
		currentNodeList.sort()
		outfile.write('subgraph G0 {\n\t"%s" ' % currentNodeList[0])
		for anode in currentNodeList[1:]:
			outfile.write('-- "%s" ' % anode)
		outfile.write(' [ weight = 100 ] ;\n\tordering = out ;\n}\n')
		for line in currentEdgeList:
			outfile.write(line)
		outfile.write('}\n')
		outfile.close()
		outstat.write('%s\t%d\t%d\t%d\n' % (node, len(currentNodeList), len(currentEdgeList), localCount[0]))

print 'generating pngs'
for node in treeList:
		output = os.popen('dot -Tpng ' + outprefix + '.' + node + '.gv > ' + outprefix + '.' + node + '.png')
outstat.close()
